 

{
    Game.i

      Die hier folgenden Routinen sind alle fr die Benutzung
      in den Spielen gedacht.
      Nhere Informationen: siehe Dokumentation.
}

{ - Copyright und Revisionsnummer fr die verwendeten Routinen -------- }

CONST
    CopyRight : string = "7. Juni 1993 , Jrg Wach ";
    RevNummer : string = "Version V1.20";

{$I "include:Exec/libraries.i"  }
{$I "include:exec/interrupts.i"  }  { fr Permit/Forbid und VB-Server }
{$I "Include:Exec/Memory.i"}        { * fr den VB-Server * }
{$I "Include:Exec/nodes.i"}         { * Fr den VB-Server * }

{$I "include:intuition/intuition.i"}

{$I "include:graphics/Pens.i"      }
{$I "include:graphics/Text.i"      }
{$I "include:graphics/Graphics.i"  }
{$I "include:graphics/rastport.i"  } { fr den Rastport }
{$I "include:graphics/blitter.i"  }  { fr die Blitter-Funktionen }

{$I "Include:Hardware/intbits.i"} { Fr den VBServer. }
{$I "Include:Libraries/DOS.i"}      { * Fr die Sample-Routinen. * }
{$I "Include:Utils/StringLib.i"}    { * Fr die Sample-Routinen. * }


{ - Die verwendeten Typen, Constanten und Variablen. ------------------ }


TYPE
        ObjektDef = record  { die Definition meiner Spielobjekte }
            Ox      :   short;  { x-Position linke obere Ecke }
            Oy      :   short;  { y-Position linke obere Ecke }
            Sizex   :   short;  { x-size }
            Sizey   :   short;  { y-size }
            Speedx  :   short;  { x-Geschwindigkeit }
            Speedy  :   short;  { y-Geschwindigkeit }
            Phase1  :   short;  { Bewegungsphasenzhler1 }
            Phase2  :   short;  { Bewegungsphasenzhler2 }
            typ     :   short;  { Objekttyp }
        end;

CONST
        Objektsize : integer = sizeof(ObjektDef); { Gre eines Objektes }

VAR
        Objekt     : array[0..255] of ObjektDef;  { Max. Anzahl der Objekte }
        Picture    : array[1..100] of Imageptr;  { Max. 100 Bilder. Daten
                                                  nur als Pointer ( um
                                                  schneller Bilder
                                                  zuzuordnen) }

        blitctrl        : short;    { Globale Variable fr Blitterergebnis }
        BlittiSpeicher  : Address;  { Wird bentigt, weil berschneidungen
                                      bei der Bearbeitung auftreten !!! }
        MyBitMap        : Address;  { Adresse der BitMap }
        MyRPort         : RastPortPtr;
{ --------------------------------------------------------------------- }
{ - Die verwendeten Typen, Variablen und Konstanten fr den VB-Server - }
{ --------------------------------------------------------------------- }

        vbint : InterruptPtr;
        VBcounter : integer;

{ --------------------------------------------------------------------- }
{ - Die verwendeten Typen, Konstanten und Variablen fr die Playsample  }
{ - Routinen. --------------------------------------------------------- }
{ --------------------------------------------------------------------- }
type
    Voice8Header = record
        oneShotHiSamples,
        repeatHiSamples,
        samplesPreHiCycle : Integer;
        samplesPerSec : Short;
        ctOctave        : Byte;
        sCompression    : Byte;
        volume : Integer;
    end;

    Sampletabdef = record
        dbuf    : Address;      { * Enthlt die Adresse des Samplebuffers. * }
        dlen    : integer;      { * Lnge des Samples. * }
        dhz     : short;        { * Tonhhe. * }
    end;

    FibTable = Array [0..15] of Byte;

const
    FP          : FileHandle = Nil;
    codeToDelta : FibTable = (-34, -21, -13, -8, -5, -3, -2, -1, 0,
                                1, 2, 3, 5, 8, 13, 21);
    Sampletab   : array[1..10] of Sampletabdef = (
                  ( Nil, 0, 0),
                  ( Nil, 0, 0),
                  ( Nil, 0, 0),
                  ( Nil, 0, 0),
                  ( Nil, 0, 0),
                  ( Nil, 0, 0),
                  ( Nil, 0, 0),
                  ( Nil, 0, 0),
                  ( Nil, 0, 0),
                  ( Nil, 0, 0)                    );

    Sampletabsize : integer = sizeof(Sampletabdef);
    Channel : byte = 0;     { * Enthlt die Nummer des neu zu belegenden
                                Kanals. * }
var
    VHeader     : Voice8Header;

{ --------------------------------------------------------------------- }


Procedure GraphCollision( x1, y1, xsize, ysize : short);
{ Testet einen BitMapBereich auf vorhandene Punkte. xsize und ysize
  bestimmen das Ausma des zu testenden Bereiches. }
    External;

Function CollObjekt(von, bis, x1, y1, sizex, sizey : short) : short;
{ Die Funktion ermittelt, welches Objekt in dem Rechteck x1, y1,
  x1+sizex und y1+sizey Kollidiert ist. Hierbei kann ein von / bis
  Bereich fr die Objektuntersuchung angegeben werden (0 - 255 ).
  Wird als Von-Wert -1 angegeben, so werden alle Objekte untersucht und
  die erste Objektnummer, die zur Kollision fhrte, zurck gegeben.
  Ist der Rckgabewert -1, so gab es eine Kolision mit einem nicht
  definierten Objekt bzw. das Objekt wurde nicht gefunden.
}
    External;

Procedure DrawObjekt( VonNr, BisNr : short );
{   Zeichnet die mit VonNr bis BisNr gekennzeichnete Objekte. }
    External;

Procedure UnDrawObjekt( VonNr, BisNr : short );
{   Lscht die mit VonNr bis BisNr gekennzeichnete Objekte. }
    External;

Function GetChar() : byte;
{ Liefert den RAW-Wert einer Taste zurck.
  Ein paar Tastencodes:     AMIGA-links   : $33
                            AMIGA-rechts  : $31
                            DEL           : $73
                            Cursor hoch   : 103
                            Cursor runter : 101
                            Cursor rechts :  99
                            Cursor links  :  97
}
    External;

Function GetJoy2(): byte;
{ Gibt folgende Werte zurck:
    0 - Joystick wurde nicht berhrt
    1 - Joystick nach rechts
    2 - Joystick nach links
    4 - Joystick nach hinten
    8 - Joystick nach vorne
   16 - Feuertaste gedrckt
}
    External;

Function ChipCopy( Source : Address; Size : integer) : Address;
{ Allokiert ChipMem in der Gre Size und kopiert die Daten von
  der Addresse Source dort hinein. Zurckgegeben wird die ChipMem
  Adresse.
}
    External;

Procedure IntToStr6(s : string; i : integer);
{ Konvertiert positive Zahlen in das Stringformat mit fhrenden
    Nullen. Max. 6 Nullen und max. die Zahl 999999 }

    External;

Procedure PowerLEDON();
{ Macht die PowerLed an. }
    External;

Procedure PowerLEDOFF();
{ Macht die PowerLed aus. }
    External;

{ --------------------------------------------------------------------- }
{ ---------   VB-Server                    ---------------------------- }
{ --------------------------------------------------------------------- }

Procedure InitVB();
{ * Initialisiert den VB-Server. * }
    External;

Procedure Exitvb();
{ * Gibt den VB-Server wieder frei. * }
    External;

Procedure Settime();
{ * Setzt den VB-Server-Wert uf 0. * }
    External;

Function Gettime(): integer;
{ * Liefert den Wert des VBServer zurck. * }
    External;

Procedure WaitVB(ticks : short);
{ * Wartet ticks Ticks vom VB. * }
    External;

{ --------------------------------------------------------------------- }
{ ---------   Playsample                   ---------------------------- }
{ --------------------------------------------------------------------- }

Procedure FreeSample(Nummer: byte);
{ * Gibt das Sample mit der Nummer nummer aus der Sampletab wieder
    frei inkl. aller belegter Speicherbereiche. * }
    External;

Procedure PlaySample(nummer : short);
{ * Spielt den in der Sampletab abgelegten Sound ab. * }
    External;

Function LoadSample(Nummer : byte; name : String): short;
{ Ldt ein IFF-8SVX Sample und weit diesem alle erforderlichen Werte
  zu.
  Returncodes :  0 ---> Sample konnte O.K. initialisiert werden.
                -1 ---> File konnte nicht geffnet werden.
                -2 ---> Kein Filename.
                -3 ---> Sampleplatz schon belegt.
                -4 ---> Kein IFF-8SVX-File.
                -7 ---> Kein Speicher fr Sample.
                -9 ---> Kein Speicher fr Dekompression.
               -10 ---> Unbekannter Kompression-Type.
}
    External;


